/* 
 * Sam Song
 * CSE142 BH, Spring 1999
 * Homework 4
 * SAM WARS
 *
 *
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
/*
#define TRUE    		1
#define FALSE   		0
*/

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	125

/* Number of buttons */
#define NUM_BUTTONS 	9


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	5

/* Height and width of a single tank */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40


/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y, int sky_color);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update tank speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int *tank_speed,
				   int *tank_direction, int *tank_color, int *tank_num, int *ray);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_y,int *sky_color,int *sun_direction);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int *x, int *direction, int speed, int *tank_num);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x[MAX_VEHICLES], int y, int color,int num);

/* Draw a single tank of the given color with horizontal */
/* center x and bottom y*/
void draw_tank(int x, int y, int color);

/* Display error message if internal error is detected. */
void something_is_wrong (void);

/* Draw a single UFO of the given color with horizontal */
/* center x and bottom y*/

void draw_ufo(int x, int y);

/*update UFO Cordinates*/

void move_ufo(int *ufo_x);

void deathray(int tank_x[MAX_VEHICLES],int *ufo_x, int *tank_num);
/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */
	int sky_color	;			/*color of sky*/
	int sun_direction;			/*direction of sun*/
	/* Information about vehicles in the animation:							*/
	/* [Only one tank now - will need to be changed to add more]				*/
	int tank_x[MAX_VEHICLES]={0,0,0,0,0}, tank_y;		/* current position of the tank					*/
	int tank_direction;		/* current direction: +1=right, -1=left			*/
	int tank_color;			/* color of the tank								*/
	int tank_speed;			/* speed in pixels per tick when traffic moving	*/	
	int traffic_moving;		/* = "traffic is currently moving"				*/
	int tank_num;			/*number of tanks on the road*/

	/* Information about UFO*/
	
	int ufo_x, ufo_y;
	int ray;
	ray = FALSE;
	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = 0;
	sun_y = GP142_YMAX - 35;
	sun_direction= -1;
	sky_color=ICE_BLUE;
	
	/* set initial conditions for the UFO */
	
	ufo_x	= -GP142_XMAX;
	ufo_y	= +GP142_YMAX-40;
	
	
	/* set initial conditions for the tank */
	
	tank_y = HIGHWAY_CENTER;
	tank_direction = +1;
	tank_speed = 5;
	tank_color = RED;
	traffic_moving = TRUE;
	tank_num =1;
	
	
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x,sun_y,sky_color);
	draw_buttons( );
	draw_traffic(tank_x, tank_y, tank_color,tank_num);
	draw_ufo(ufo_x,ufo_y);
	
	
	
	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button( mouse_x, mouse_y, &traffic_moving, &tank_speed,
								&tank_direction, &tank_color, &tank_num, &ray);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun( &sun_y, &sky_color, &sun_direction);
			if (traffic_moving)
				move_traffic(tank_x, &tank_direction, tank_speed,&tank_num);
				move_ufo(&ufo_x);
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(sun_x, sun_y,sky_color);
		draw_buttons();
		draw_traffic(tank_x, tank_y, tank_color,tank_num);
		draw_ufo(ufo_x,ufo_y);
		if (ray==TRUE)
			deathray(tank_x,&ufo_x,&tank_num);
		
		
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y, int sky_color)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */

	/* Draw the sky */
	GP142_rectangleXY(sky_color, -GP142_XMAX, -GP142_YMAX,
	GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 60);

	/* Draw the ground, highway, and text legend */


	GP142_rectangleXY(GOLD, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);

	GP142_rectangleXY(BLUE, -GP142_XMAX,HIGHWAY_CENTER ,
		GP142_XMAX, HORIZON, FILL);

	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	GP142_lineXY(BLACK,
					-GP142_XMAX,HIGHWAY_CENTER,
					 GP142_XMAX,HIGHWAY_CENTER,
					 FILL);

	
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the tank.");

	
} /*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(MED_GRAY,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "New Color");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Add Tank");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Remove Tank");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Shoot DEATH RAY!");





}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update tank speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int *tank_speed,
				   int *tank_direction, int *tank_color, int *tank_num, int *ray)
{
	int buttonNum;		/* number of selected button */

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		*tank_speed = *tank_speed + 1;
		break;
	case 3:
		/* slow down */
		*tank_speed = *tank_speed - 1;
		if (*tank_speed < 0)
			*tank_speed = 0;
		break;
		
	case 4:
		/* reverse */
		*tank_direction = - *tank_direction;
		break;
	case 5:
		/* change tank color */
		*tank_color = (*tank_color+1) % MAX_COLORS;
		break;
	case 6:
		/* change number of tanks*/
		
		if (*tank_num<MAX_VEHICLES)
		
		*tank_num=*tank_num+1;
		
		
		break;
	case 7:
		if (*tank_num>0)
		*tank_num= *tank_num-1;
		break;
			
	case 8:
		if (*ray == TRUE)
		{
		*ray = FALSE;
		}
		else 
		*ray = TRUE;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun( int *sun_y, int *sky_color,int *sun_direction) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	
	
	
	

	
	switch(*sun_y)
	{
	
	case GP142_YMAX - 35: 
		*sky_color=ICE_BLUE;
		break;

	case 0:
		*sky_color=ORANGE;
		break;
	case -GP142_YMAX*1/2:
		*sky_color=RED;
		break;
	case -GP142_YMAX*3/4:
		*sky_color=BLACK;
		break;

	}	
	if (*sun_y ==-GP142_YMAX) {
		*sun_direction=1;
		
		}
	else if (*sun_y == GP142_YMAX){
		*sun_direction=-1;
		}
			
		*sun_y=*sun_y+(*sun_direction);
		
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int x[MAX_VEHICLES], int *direction, int speed,int *num) {
	/* Note: If there is more than one vehicle, this should */
	/* be updated to adjust all vehicle coordinates */

	int trial_x;		/* new value for x coordinate */
	int i	   ;	
	/* move vehicle.  If it moves off the edge, reverse direction */
	for (i=0;i<*num;i=i+1)
	{
	trial_x = x[i] + (*direction * speed);
	
		
	/*
	if (abs(trial_x) > GP142_XMAX - CAR_WIDTH/2)

	*direction = - (*direction);
	*/
	if (trial_x > GP142_XMAX - CAR_WIDTH/2)
	x[i] = (-GP142_XMAX + CAR_WIDTH/2)+ (*direction * speed);
	else if (-trial_x >	GP142_XMAX - CAR_WIDTH/2)
	x[i] = (GP142_XMAX - CAR_WIDTH/2)+ (*direction * speed);
	
	else
	x[i] = trial_x;
	}
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x[MAX_VEHICLES], int y, int color,int num) {
	/* Note: needs to be changed if there is more than */
	/* one vehicle */
	int i;
	for (i=0;i<num;i++)
		draw_tank(x[i],y,color);
}



/* Draw a single tank of the given color with horizontal */
/* center x and bottom y*/

void draw_tank(int x, int y, int color) {
	GP142_rectangleXY(color,  x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						 x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/6, y + CAR_HEIGHT*3/4,
						x + CAR_WIDTH/6, y + CAR_HEIGHT, FILL);

	GP142_lineXY(color, x + CAR_WIDTH/6, y + CAR_HEIGHT*1/2, x+CAR_WIDTH/2,y+CAR_HEIGHT,4);

}


void draw_ufo(int x, int y)
	{
	
	GP142_ovalXY(23,x+ 24,y+3,55+x,y+9 , FILL);
	GP142_ovalXY(23,x+ 35,y+12,x+44,y+6,2);

	}

void move_ufo(int *x)
	{
	int trial_x	;		/* new value for x coordinate */
		
	/* move vehicle.  If it moves off the edge, reverse direction */

	trial_x = *x + (10);

if (trial_x > GP142_XMAX - CAR_WIDTH/2)
	*x = (-GP142_XMAX + CAR_WIDTH/2)+ (10);
	else if (-trial_x >	GP142_XMAX - CAR_WIDTH/2)
	*x = (GP142_XMAX - CAR_WIDTH/2)+ (10);
	else
	*x = trial_x;
	}



void deathray(int tank_x[MAX_VEHICLES], int *ufo_x, int *num)
	{
	int i;
	
	GP142_lineXY(YELLOW,*ufo_x+35,GP142_YMAX-40,*ufo_x+100,HIGHWAY_CENTER,4);
	for (i=0;i<*num;i++)
	{
	if (tank_x[i]==*ufo_x+100)
		{
		for (i;i<*num;i++)
		{
		tank_x[i]=tank_x[i+1];
		}
		i=*num+1;
		*num=*num-1;
	
	}
	}
	}
/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}